Subject: Map time and weather Issue
Description

I use a alt Char on windows and my main on linux and it seems most of the time when my alt care planing me we have dif weather
also the time on windows seems to change faster than on linux it makes it a bit harder to get them exc mats.

History
#1 - 07/07/2011 07:41 pm - usm4rin3

Thats why no one can figure out how the weather system works.  I already digged into this issue , and in fact, the Linux weather is the right one, that
means its equal to the weather the server expects.

Its caused by a compilation issue. The 'random' number generator that feeds the weather system gives different values in the windows compilation.

You can check with your linux version, that every time it 'sap storms' in LoC, you will get sup zun amber. Thats why I know its the right weather. In
windows, its random.

#2 - 07/07/2011 07:43 pm - Naush

Ah, yes I remember :)

IIRC, Weather system use a noise matrix (CRandomGrid3D) to perform this job. The noise generation is based on the libc PRNG aka: srand(), so the
result is platform dependent.

This is probably why your two OS have different weather :)

#3 - 10/29/2011 03:35 pm - kervala
- Category set to NeL: General
- Status changed from New to Assigned
- Assignee set to Sywindt

#4 - 10/29/2011 03:36 pm - kervala

Please someone could check if commited patch is enough to fix the bug ? Thanks :)

#5 - 10/29/2011 04:37 pm - usm4rin3

kervala wrote:

Please someone could check if commited patch is enough to fix the bug ? Thanks :)
If I remember right, I don't think this patch will fix it, because there are other 'obscure' reasons (rounding) with the fp unit in linux. I think that maybe the
easiest way to solve this is to create this precomputed noise table (CRandomGrid3D) in a binary file, and use it, instead of calculating the values on
initialization.

Of course this would lead to the problem of packaging this file with the client/server, and its not a elegant solution.

#6 - 10/29/2011 06:00 pm - kervala

You're right, it should be related to OptFastFloor inline function which is using default rounding under Linux and round down under windows x86
(under x86-64 it shouldn't use the same code because inline ASM is disabled).

Are fast floor tricks still useful under Windows in VC++ 2008 and later ?

#7 - 10/29/2011 11:25 pm - usm4rin3

I dont know....

I messed with some notes I wrote about it a long time ago, maybe it can help:

-on windows: FPU using ROUND_DOWN and DOUBLE_PRECISION and table populated with msvc rand() (I think you took care of this already)
-on linux: FPU not touched, default should be: ROUND_NEAR, SINGLE_PRECISION.

#8 - 10/30/2011 09:48 am - kervala

I will try some benchmarking :)

#9 - 12/07/2011 11:07 pm - dnk-88
- Target version set to Version 0.9.0

#10 - 03/02/2012 05:46 am - usm4rin3

Im not sure if this is resolved in the last patch , but I think I know at least one collateral effect.

The material position inside a deposit has changed with this new 'random table'. This can be observed in deposits with lots of mats (like
basic/fine/choice of all families). People must find now in the vicinity where the mat is. It dosn't change much, but it breaks the knowledge of years of
digging.

#11 - 03/13/2012 02:40 pm - kervala

Please could you confirm if this patch fixed the issue ?

#12 - 05/18/2012 08:51 pm - kervala
- Assignee changed from Sywindt to kervala

#13 - 05/18/2012 08:56 pm - kervala
- Status changed from Assigned to Resolved
- % Done changed from 0 to 100
usm4rin3 wrote:

I dont know....

I messed with some notes I wrote about it a long time ago, maybe it can help:

-on windows: FPU using ROUND_DOWN and DOUBLE_PRECISION and table populated with msvc rand() (I think you took care of this already)
-on linux: FPU not touched, default should be: ROUND_NEAR, SINGLE_PRECISION.

You were right :)

We disabled fast floats and it worked fine :) Weather is exactly the same under Windows and other OSes now ! Thanks a lot :)

#14 - 06/14/2012 03:12 pm - kervala

Applied in changeset commit:380f811ebb8c.

#15 - 09/24/2012 04:10 pm - kervala
- Status changed from Resolved to Closed

#16 - 10/15/2012 04:47 am - usm4rin3

Im not sure if the clients (win/linux/mac) are displaying the same weather, but I've made a small verification today and im prety sure that the windows
client is with a different weather than the server.

#17 - 10/16/2012 10:08 am - kervala

Did you check with shift+F2 in DEV client ?

#18 - 10/17/2012 05:43 pm - usm4rin3

No, I don't have it. You can verify that in one moment, tracking a sup on a 'sap storm' weather is successful, and on another moment (another cycle),
its not (for the same material). The 'sap storm' weather is unique (not shared as the 'fair' weather) and can be used as a solid reference. I hope it
helps.
